<?php

namespace App\Installation\Commands\Concerns;

use App\Installation\Commands\CustomCommand;
use Illuminate\Support\Facades\Storage;

trait DependsOnNpm
{
    protected function npm(): string
    {
        if ($this->hasYarnExecutable() && $this->hasYarnLock()) {
            return 'yarn';
        }

        return 'npm';
    }

    protected function hasYarnExecutable(): bool
    {
        $command = new CustomCommand('which yarn');
        $command->silentExecute();

        return $command->getOutput() !== '';
    }

    protected function hasYarnLock(): bool
    {
        return Storage::disk('project')->exists('yarn.lock');
    }
}
