<?php

namespace App\Installation\Contracts;

use App\Installation\Commands\CustomCommand;
use ArrayIterator;
use IteratorAggregate;

abstract class Instructions implements IteratorAggregate
{
    abstract public function canRun(): bool;

    abstract protected function commands(): array;

    abstract public function name();

    public function getIterator()
    {
        return new ArrayIterator($this->commands());
    }

    protected function command($command): CustomCommand
    {
        return new CustomCommand($command);
    }
}
