<?php

namespace App\Tasks;

use App\Git\Cloneable;
use Illuminate\Support\Facades\Storage;

class CopyProjectTask
{
    /**
     * @var \App\Git\Cloneable
     */
    private $cloneable;

    /**
     * @var string
     */
    private $destination;

    public function __construct(Cloneable $cloneable, string $destination)
    {
        $this->cloneable = $cloneable;
        $this->destination = $destination;
    }

    public function __invoke()
    {
        $allFiles = Storage::disk('git-clone')->allFiles($this->cloneable->getFolder());
        foreach ($allFiles as $filePath) {
            $stream = Storage::disk('git-clone')->readStream($filePath);

            Storage::disk('local')->put($this->destination . '/' . $this->stripFolder($filePath), $stream);
        }
    }

    private function stripFolder(string $filePath): string
    {
        return str_replace($this->cloneable->getFolder() . '/', '', $filePath);
    }
}
